﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=3.82
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type PackageType ( _
		PackageName As String, _
		AppLabel As String, _
		Icon As Object)
		
	Dim tmrAnimCatTimeout As Timer 
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim ULV As UltimateListView
	Dim CatULV As UltimateListView 
	Dim AnimInCatULV As AnimationPlus 
	Dim AnimOutCatULV As AnimationPlus 

	Dim PM As PackageManager 

	Dim HeaderIDOffset As Int = 10000
	Dim StickyPanel As Panel
	Dim CatULV_Width As Int = 100dip
	
	Dim packageList As List 
	
	Dim CatULVVisible As Boolean 
	
	Dim bmpChecked As Bitmap   = LoadBitmap(File.DirAssets,"btn_check_on_holo_light.png")
	Dim bmpUnchecked As Bitmap = LoadBitmap(File.DirAssets,"btn_check_off_holo_light.png")
	Dim oben As Int = 50dip
End Sub

Sub Activity_Create(FirstTime As Boolean)
	ULV.Initialize(0, 0, "", "ULV")
	ULV.SetStyle(ULV.STYLE_HOLO_LIGHT)
	ULV.FadingEdges(False)
	ULV.DividerHeight = 0
	ULV.AddLayout("Header", "Header_LayoutCreator", "Header_ContentFiller", 60dip, False)
	ULV.AddLayout("Item", "Item_LayoutCreator", "Item_ContentFiller", 60dip, True)
	ULV.SelectionMode = ULV.SELECTION_MULTIPLE 
	ULV.SelectWithClick = True
	
	CatULV.Initialize(0, 0, "", "CatULV")
	CatULV.SetStyle(ULV.STYLE_HOLO_LIGHT)
	CatULV.DividerHeight = 0
	CatULV.AddLayout("CatItem", "CatItem_LayoutCreator", "CatItem_ContentFiller", 32dip, True)
	
	ProgressDialogShow("Waking up dead cycles...")
	DoEvents
	DoEvents

	packageList.Initialize 
	For Each packagename As String In PM.GetInstalledPackages
		Dim pMap As PackageType : pMap.Initialize 
		pMap.packagename = packagename
		pMap.applabel = PM.GetApplicationLabel(packagename)
		pMap.Icon = PM.GetApplicationIcon(packagename)
		packageList.Add(pMap)
	Next

	ProgressDialogHide

	packageList.SortType("AppLabel",True)

	Dim ID As Long

	For Each pType As PackageType In packageList
		Dim SectionName As String = pType.AppLabel.CharAt(0)
		SectionName = SectionName.ToUpperCase
		If ULV.NumberOfItemsInSection(SectionName) = -1 Then
			'Section not created yet
			ULV.AddSection(SectionName, "HEADER", "ITEM", "")
			ULV.SetSectionHeader(ID + HeaderIDOffset, SectionName)
		End If
		ULV.AddItemToSection(ID, SectionName)
		ID = ID + 1
	Next

	Activity.AddView(ULV, 0, oben, 100%x, 100%y-48dip)

	'Creates the sticky panel over the ULV
	StickyPanel.Initialize("")
	Activity.AddView(StickyPanel, 0, oben, 100%x, 60dip)
	Header_LayoutCreator("", StickyPanel)	

	AnimInCatULV.InitializeTranslate("AnimInCatULV", 0, 0, -CatULV_Width, 0)
	AnimOutCatULV.InitializeTranslate("AnimOutCatULV", 0, 0, CatULV_Width, 0)
	AnimInCatULV.Duration = 500
	AnimOutCatULV.Duration = 500
	
	tmrAnimCatTimeout.Initialize("tmrAnimCatTimeout", 2000)
	
	ULV.SwipeMode = ULV.SWIPE_MODE_LIST_DIR_LEFT 

	Dim btnOK, btnCancel As Button 
	btnOK.Initialize("btnOK")
	btnCancel.Initialize("btnCancel")
	Activity.AddView(btnOK, 0, 100%y-48dip, 50%x, 48dip)
	Activity.AddView(btnCancel, 50%x, 100%y-48dip, 50%x, 48dip)
	btnOK.Text = "Done"
	btnCancel.Text = "Cancel"
	
	Dim SectionMap As Map = ULV.GetSectionsMap
	CatULV.BulkAddItems(SectionMap.Size, "CATITEM", 0)
	Activity.AddView(CatULV, 100%x, 0, CatULV_Width, 100%y)

	CallSubDelayed(Me, "Delay_Anim")
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnOK_Click
	'Create a list of package names selected
	Dim selectedPackages As List : selectedPackages.Initialize 
	For Each ItemID In ULV.GetSelectedIDs
		Dim ptype As PackageType = packageList.Get(ItemID)
		selectedPackages.Add(ptype.PackageName)
	Next
	Log(selectedPackages)
	Activity.Finish 
End Sub

Sub btnCancel_Click
	Activity.Finish 
End Sub

Sub ULV_SwipeBegin(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int) As Boolean
	Return True
End Sub

Sub ULV_Swiped(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int, DeltaX As Int)
	CallSubDelayed(Me, "Delay_Anim")
End Sub

Sub Header_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	'Each header has a label
	LayoutPanel.Color = Colors.RGB(58,200,58)

	Dim lbl As Label
	lbl.Initialize("HeaderLabel")
	lbl.Color = Colors.Transparent
	lbl.TextColor = Colors.Black
	lbl.TextSize = 28
	lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
	lbl.Typeface = Typeface.DEFAULT_BOLD 
	LayoutPanel.AddView(lbl, 20dip, 5dip, LayoutPanel.Width - 20dip, LayoutPanel.Height - 9dip)

End Sub

Sub Item_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	'Each item has an imageview, a label and a checkbox
	Dim IV As ImageView
	IV.Initialize("")
	LayoutPanel.AddView(IV, 20dip, 5dip, LayoutPanel.Height - 10dip, LayoutPanel.Height - 10dip)

	Dim lbl As Label
	lbl.Initialize("")
	lbl.Color = Colors.Transparent
	lbl.TextColor = Colors.Black
	lbl.TextSize = 20
	lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
	Dim X As Int = IV.Left + IV.Width + 5dip
	LayoutPanel.AddView(lbl, X, 5dip, LayoutPanel.Width - X, LayoutPanel.Height - 9dip)
	
	Dim chk As Panel 
	chk.Initialize("")
	LayoutPanel.AddView(chk, LayoutPanel.Width - 54dip, (LayoutPanel.Height - 38dip)/2, 38dip, 38dip)
End Sub

Sub Header_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	'Updates the text of the label
	Dim lbl As Label = LayoutPanel.GetView(0)
	lbl.Text = ULV.GetItemSectionName(Position)
End Sub

Sub Item_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	Dim PMap As PackageType = packageList.Get(ItemID)

	'Updates the icon of the item
	Dim IV As ImageView = LayoutPanel.GetView(0)
	IV.Background = PMap.Icon

	'Updates the text of the label
	Dim lbl As Label = LayoutPanel.GetView(1)
	lbl.Text = "ItemID = " & ItemID
	lbl.Text = PMap.AppLabel 

	'The item becomes green when selected, and the checkbox is checked
	Dim chk As Panel = LayoutPanel.GetView(2)
	chk.Tag = ItemID
	
	If ULV.IsSelected(Position) Then
		LayoutPanel.Color = Colors.ARGB(70, 92, 197, 104)
		chk.SetBackgroundImage(bmpChecked)
		
	Else
		LayoutPanel.Color = Colors.White 
		chk.SetBackgroundImage(bmpUnchecked)
	End If
	
End Sub

Sub ULV_Scrolled(FirstVisibleItem As Int, VisibleItemCount As Int, TotalItemCount As Int, IsAtTop As Boolean, IsAtBottom As Boolean)
	'Updates the text of the sticky panel
	Dim SectionName As String = ULV.GetItemSectionName(FirstVisibleItem)
	If SectionName = "" Then Return
	Dim HeaderID As Long = ULV.GetSectionHeaderID(SectionName)
	Header_ContentFiller(HeaderID, "HEADER", StickyPanel, FirstVisibleItem)

	'Updates the vertical position of the sticky panel
	StickyPanel.Top = oben
	Dim SectionNameOfNextItem As String = ULV.GetItemSectionName(FirstVisibleItem + 1)
	If SectionNameOfNextItem = "" Then Return
	If SectionName <> SectionNameOfNextItem Then
		'The first visible item is the last item before the next header
		StickyPanel.Top = ULV.GetVisibleTop(0) + oben
	End If
End Sub

Sub ULV_ItemClick(ItemID As Long, Position As Int, ClickedPanel As Panel)
	Log(ItemID)
	If ItemID >= HeaderIDOffset Then 'Header
		AnimInCatULV.Start(CatULV)	
	End If
End Sub

Sub HeaderLabel_Click
	CallSubDelayed(Me, "Delay_Anim")
End Sub

Sub Delay_Anim
	If CatULVVisible = True Then
		Return	
	End If
	CatULVVisible = True
	AnimInCatULV.Start(CatULV)
	ULV.RefreshContent 
End Sub

Sub CatItem_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	'Just a label
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Color = Colors.Transparent
	lbl.TextColor = Colors.Black
	lbl.TextSize = 16
	lbl.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	LayoutPanel.AddView(lbl, 2dip, 2dip, LayoutPanel.Width - 2dip, LayoutPanel.Height - 4dip)
	
End Sub

Sub CatItem_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	Dim lbl As Label = LayoutPanel.GetView(0)
	lbl.Text = ULV.GetSectionsMap.GetKeyAt(Position)
End Sub
Sub CatULV_ScrollStateChanged(ScrollState As Int)
	tmrAnimCatTimeout.Enabled = False
	If ScrollState = ULV.SCROLLSTATE_IDLE Then
		tmrAnimCatTimeout.Enabled = True
	End If
End Sub

Sub CatULV_ItemClick(ItemID As Long, Position As Int, ClickedPanel As Panel)
	Dim NumberOfVisibleItems As Int = ULV.GetLastVisiblePosition - ULV.GetFirstVisiblePosition
	Dim JumpPosition As Int = ULV.GetSectionsMap.GetValueAt(Position) + NumberOfVisibleItems - 1
	If ULV.GetFirstVisiblePosition > JumpPosition Then
		JumpPosition = ULV.GetSectionsMap.GetValueAt(Position)
	End If
	If JumpPosition >= ULV.NumberOfItems Then JumpPosition = ULV.NumberOfItems - 1
	ULV.JumpTo(JumpPosition, True)
End Sub

Sub CatULV_Scrolled(FirstVisibleItem As Int, VisibleItemCount As Int, TotalItemCount As Int, IsAtTop As Boolean, IsAtBottom As Boolean)
End Sub
 
Sub AnimInCatULV_AnimationEnd
	AnimInCatULV.Stop(CatULV)
	CatULV.Left = CatULV.Left - CatULV_Width
	tmrAnimCatTimeout.Enabled = True
End Sub

 Sub AnimOutCatULV_AnimationEnd
	AnimOutCatULV.Stop(CatULV)
	CatULV.Left = CatULV.Left + CatULV_Width
	CatULVVisible = False
End Sub

 Sub tmrAnimCatTimeout_Tick
	AnimOutCatULV.Start(CatULV)
	tmrAnimCatTimeout.Enabled=False 
End Sub

